import java.math.*;
public class CalculateNDCG {
	public double cal_NDCG(String[] realSort,String[] ideaSort,int r){
		double nDCG=0.0;
		double DCG=0.0;
		double iDCG=0.0;
		int[] gain_score=gain(realSort, ideaSort, r);
		for(int i=0;i<realSort.length;i++){
			DCG+=gain_score[i]*Math.log(2)/Math.log(2+i);
		}
		int len_i = ideaSort.length;
		int n = len_i / r; // ÿȼĿ
		int lev=r+1;
		for(int i=0;i<len_i;i++){
			if(i%n==0)
			{
				lev--;
			}
			iDCG+=(Math.pow(2, lev)-1)*Math.log(2)/Math.log(2+i);
		}
		return nDCG=DCG/iDCG;
	}

	int[] gain(String[] realSort, String[] ideaSort, int r) {
		int len_r = realSort.length;
		int len_i = ideaSort.length;
		int gain_score[] = new int[len_r];
		int n = len_i / r; // ÿȼĿ
		for (int i = 0; i < len_r; i++) {
			int loc = find_loc(realSort[i], ideaSort);
			if(loc==-1){
				gain_score[i]=0;
			}else {
				gain_score[i] = (int)Math.pow(2, r - loc / n)-1;
			}
		}
		return gain_score;
	}

	int find_loc(String sub, String aim_strings[]) {
		for (int i = 0; i < aim_strings.length; i++) {
			if (sub == aim_strings[i]) {
				return i;
			}
		}
		return -1;
	}
}
