package support;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class DataHandle {
	/**
	 * 
	 * @param dataбFrobeniusһ
	 * @return
	 */
public static List<Double> frobenius(List<Double> data) {
	Double sum_square=0d;
	Iterator<Double> iterator=data.iterator();
	while(iterator.hasNext()){
		double datai=iterator.next();
		sum_square+=datai*datai;
	}
	double frob_num= Math.pow(sum_square, 0.5);
	List<Double> frob_list=new ArrayList<Double>();
	iterator=data.listIterator();
	
	while(iterator.hasNext()){
		frob_list.add(iterator.next()/frob_num);
	}
	return frob_list;
}
}
