package support;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.*;
import java.lang.Math;
public class Similarity extends Thread{
	public Double cla_EX(List<Double> data) {
		int len = data.size();
		Double ex = 0d;
		Iterator<Double> iterator = data.iterator();
		Double sum = 0d;
		while (iterator.hasNext()) {
			sum += iterator.next();
		}
		return ex = sum / len;
	}
	public Double cla_sim(List<Double> data1, List<Double> data2) {
		int len = data1.size();
		List<Double> data3 = new ArrayList<Double>();
		List<Double> data4 = new ArrayList<Double>();
		List<Double> data5 = new ArrayList<Double>();
		Iterator<Double> iterator1 = data1.iterator();
		Iterator<Double> iterator2 = data2.iterator();
		while (iterator1.hasNext()) {
			Double temp = iterator1.next();
			data3.add(temp * temp);
		}
		while (iterator2.hasNext()) {
			Double temp = iterator2.next();
			data4.add(temp * temp);
		}
		iterator1 = data1.iterator();
		iterator2 = data2.iterator();
		while (iterator1.hasNext()) {
			data5.add(iterator1.next() * iterator2.next());
		}
		Double E_data1 = cla_EX(data1);
		Double E_data2 = cla_EX(data2);
		Double E_data3 = cla_EX(data3);
		Double E_data4 = cla_EX(data4);
		Double E_data5 = cla_EX(data5);
		return (E_data5 - E_data1 * E_data2)
				/ (Math.pow(E_data3 - E_data1 * E_data1, 0.5) * Math.pow(
						E_data4 - E_data2 * E_data2, 0.5));
	}
	public void operaterSql(String dataBaseName,String tablename,String column1,String column2) {
		Connection conn=new ConnectionSql(dataBaseName).connection();
		try {
			Statement st=conn.createStatement();
			String sql="select "+column1+" from "+tablename;
			ResultSet rs=st.executeQuery(sql);
			List<Double> data1=new ArrayList<Double>();
			List<Double> data2=new ArrayList<Double>();
			while (rs.next()) {
				double temp=rs.getDouble(1);
				data1.add(temp);	
			}
			 sql="select "+column2+" from "+tablename;
			 rs=st.executeQuery(sql);
			 while (rs.next()) {
				 	double temp=rs.getDouble(1);
					data2.add(temp);	
				}
			
 			 Double similarity=cla_sim(data1,data2);
			 System.out.println(similarity);
			 tablename="'"+tablename+"'";
			 column1="'"+column1+"'";
			 column2="'"+column2+"'";
			 sql="replace into similary_record(table_name,column1,column2,similarity) values ("+tablename+","+column1+","+column2+","+similarity+")";
			 st.execute(sql);
			 conn.close();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
	public static void main(String[] args) {
		Similarity similarity=new Similarity();
	//	similarity.operaterSql("ossean_db","sourceforge_project","stars","downloadCount");
		
//		similarity.operaterSql("ossean_db","match_simple","db_score","postsCount");
//		similarity.operaterSql("ossean_db","match_simple","db_score","score");
//		similarity.operaterSql("ossean_db","match_simple","db_score","favoriteCount");
//		similarity.operaterSql("ossean_db","match_simple","db_score","viewCount");
//		similarity.operaterSql("ossean_db","match_simple","db_score","answerCount");
		similarity.operaterSql("ossean_db","match_simple","postsCount","viewCount");
	}
	
}