import java.io.*;

public class SplitHugeFile {
	public void splitFile(String filename, int linesCount) {
		try {
			BufferedReader reader=new BufferedReader(new FileReader(new File(filename)));
			int count=0;
			int file_count=0;
			String tempString=null;
			BufferedWriter writer=new BufferedWriter(new FileWriter(new File(writeFilename(filename,file_count++))));
			while((tempString=reader.readLine())!=null){
				writer.write(tempString+'\n');
				count++;
				if(count>=linesCount){
					count=0;
					writer.flush();
					writer.close();
					writer=new BufferedWriter(new FileWriter(new File(writeFilename(filename,file_count++))));
					continue;
				}
			}
			writer.flush();
			writer.close();
			reader.close();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
	String writeFilename(String filename,int count){
		String wfilename=filename.substring(0, filename.length()-4);
		wfilename=wfilename+count;
		return wfilename+filename.substring(filename.length()-4, filename.length());
	}
}
