import java.sql.*;
import java.util.*;
import java.util.Date;

import support.ConnectionSql;
import update.UpdateTableColumn;

public class SplitTags {
	
	String source_table;
	String source_column1;
	String source_column2;
	String des_table;
	String des_column1;
	String des_column2;
	String postTypeId;
	
	public SplitTags() {
		this.source_table = "posts";
		this.source_column1 = "id";
		this.source_column2 = "tags";
		this.des_table = "posts_split_tags";
		this.des_column1 = "posts_id";
		this.des_column2 = "tag";
		this.postTypeId="postTypeId";
	}
	public SplitTags(String source_table, String source_column1,
			String source_column2, String des_table, String des_column1,
			String des_column2) {
		this.source_table = source_table;
		this.source_column1 = source_column1;
		this.source_column2 = source_column2;
		this.des_table = des_table;
		this.des_column1 = des_column1;
		this.des_column2 = des_column2;
	}
	public static void main(String[] args){
		SplitTags st=new SplitTags("posts","id","tags","posts_split_tags","posts_id","tag");//ǩ
		st.splitTags();
	}
	
	public int breakTest(Connection conn, String break_sql) {
		int lastId = 0;
		try {
			Statement st = conn.createStatement();
			ResultSet rs = st.executeQuery(break_sql);
			if (rs.next()) {
				lastId = rs.getInt(des_column1);
				String del_sqlString="delete from "+des_table+" where " + des_column1 + "="+ lastId;
				st.execute(del_sqlString);
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return lastId;
	}

	public void splitTags() {

		try {
			Connection conn = new ConnectionSql("ossean_db").connection();
			/*
			 * ڱڴԲ÷ҳѯ
			 */
			int page_count = 0; // ҳСҳ
			int page_size = 100000;
			int id = 0; // Ҫ
			conn.setAutoCommit(false);//ֶύ
			String tags;

			/*
			 * Ӷϵ
			 */

			String break_sql = "select "
					+ des_column1 // ϵѯ
					+ " from " + des_table + " order by " + des_column1
					+ " desc limit 0,1";
			int breakPoint = breakTest(conn, break_sql);
			/*
			 * Գٶ
			 */
			System.out.print(new Date());
			System.out.println("\t\tstart" );
			
			/*
			 * Ӳѯ߷ҳЧʣֹЧʵ˥
			 
			String sql = "select " + source_column1 + "," + source_column2
					+ " from " + source_table + " where " + source_column1
					+ " >= " + breakPoint + " limit ?,?"; // ѯ
			*/
			String sql;
			if(breakPoint>0){
				 sql = "select " + source_column1 + "," + source_column2
						+ " from " + source_table + "  where "+ source_column1+
						" >(select id from "+source_table+" order by "+ source_column1+" limit ?,1) and "+ 
						source_column1+ " >= " + breakPoint + " limit ?"; // ѯ
			}
			
			else{
			sql = "select " + source_column1 + "," + source_column2
					+ " from " + source_table + " where  "+ source_column1+
					" >(select id from "+source_table+" order by "+ source_column1+" limit ?,1) limit ?";// ѯ
			}	 
			
			String sqlInsert = " insert into " + des_table + " (" + des_column1
					+ "," + des_column2 + ") values(?,?)"; // 
			PreparedStatement p_statement = conn.prepareStatement(sql);
			PreparedStatement ps = conn.prepareStatement(sqlInsert);
			int count = 0;
			do {
				p_statement.setInt(1, page_count * page_size);
				p_statement.setInt(2, page_size);
				ResultSet rs = p_statement.executeQuery();
				boolean isEmpty = true;
				while (rs.next()) {
					isEmpty = false;
					id = rs.getInt(source_column1);
					tags = rs.getString(source_column2);
					if (tags == null)
						continue;

					tags = tags.substring(1, tags.length() - 1);
					String tag[] = tags.split("><");

					for (int i = 0; i < tag.length; i++) {
						ps.setInt(1, id);
						ps.setString(2, tag[i]);
						ps.addBatch();
					}
					if (count++ > 10000) {
						ps.executeBatch();
						ps.clearBatch();
						conn.commit();
						count = 0;
					}
				}
				if (isEmpty) {
					break;
				}
				page_count++;
				/*
				 * Գٶ
				 */
				System.out.print(new Date());
				System.out.println("\t\t" + page_count);
			} while (true);
			ps.executeBatch();
			ps.clearBatch();
			p_statement.close();
			conn.commit();
			conn.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
